<?php
/**
 * Controller that intercepts Apple Pay REST requests. Used for updating Apple Pay Wallet elements
 * such as line items, shipping, etc.
 * @since 3.0.0
 * @package Braintree/API
 *
 */
class WC_Braintree_Controller_ApplePay extends WC_Braintree_Rest_Controller {

	protected $namespace = 'applepay/';

	/**
	 *
	 * @var WP_REST_Request
	 */
	private $request;

	/**
	 *
	 * @var WP_Error
	 */
	private $error;

	public function register_routes() {
		register_rest_route ( $this->rest_uri (), 'payment-method', array( 
				'methods' => WP_REST_Server::CREATABLE, 
				'callback' => array( $this, 
						'payment_method' 
				) 
		) );
	}

	/**
	 *
	 * @param WP_REST_Request $request        	
	 */
	public function payment_method($request) {
		WC ()->cart->calculate_totals ();
		/**
		 *
		 * @var WC_Braintree_ApplePay_Payment_Gateway $gateway
		 */
		$gateway = WC ()->payment_gateways ()->payment_gateways ()[ 'braintree_applepay' ];
		return rest_ensure_response ( array( 
				'success' => true, 
				'data' => array( 
						'newLineItems' => $gateway->get_line_items (), 
						'newTotal' => array( 
								'type' => 'final', 
								'label' => $gateway->get_option ( 'store_name' ), 
								'amount' => $gateway->get_cart_total () 
						) 
				) 
		) );
	}
}